import java.util.*;

abstract class Stack
{
	abstract public void push(int n);
	abstract public int pop();
	abstract public void display();
}

class StaticStack extends Stack
{
	int arr[] = new int[10];
	int top=-1;
	public void push(int ele)
	{
		if (top<10)
		{
			top++;
			arr[top]=ele;
		}
		else
			System.out.println("Error: Array Overflow!");
	}
	public int pop()
	{
		if (top>-1)
		{
			int element = arr[top];
			top--;
			return element;
		}
		else
		{
			System.out.println("Error: Array Underflow!");
			return(-1);
		}
	}
	public void display()
	{
		for (int i = top;i>=0;i--)
		{
			System.out.print(arr[i]+" ");
		}
	}
}

class DynamicStack extends Stack
{
	ArrayList<Integer> arr = new ArrayList<Integer>();
	int top=-1;
	public void push(int ele)
	{
		if (top<10)
		{
			top++;
			arr.add(top,ele);
		}
		else
			System.out.println("Error: Array Overflow!");
	}
	public int pop()
	{
		if (top>-1)
		{
			int element = arr.get(top);
			arr.remove(top);
			top--;
			return element;
		}
		else
		{
			System.out.println("Error: Array Underflow!");
			return(-1);
		}
	}
	public void display()
	{
		for (int i = top;i>=0;i--)
		{
			System.out.print(arr.get(i)+" ");
		}
	}
}

public class Start
{
	public static void main(String[] args)
	{
		System.out.println("****Static Stack****");
		StaticStack s = new StaticStack();
		s.push(1);
		s.display();
		System.out.println(" ");
		s.push(2);
		s.display();
		System.out.println(" ");
		s.push(3);
		s.display();
		System.out.println(" ");
		s.pop();
		s.display();
		System.out.println(" ");
		s.pop();
		s.display();
		System.out.println(" ");
		System.out.println("****Dynamic Stack****");
		DynamicStack d = new DynamicStack();
		d.push(1);
		d.display();
		System.out.println(" ");
		d.push(2);
		d.display();
		System.out.println(" ");
		d.push(3);
		d.display();
		System.out.println(" ");
		d.pop();
		d.display();
		System.out.println(" ");
		d.pop();
		d.display();
		System.out.println(" ");
	}
}